VERSION 5.00
Begin VB.Form frmSimplex 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Simplex"
   ClientHeight    =   4500
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   8775
   Icon            =   "frmSimplex.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4500
   ScaleWidth      =   8775
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdChiudi 
      Caption         =   "Chiudi"
      Height          =   375
      Left            =   180
      TabIndex        =   11
      Top             =   3780
      Width           =   2055
   End
   Begin VB.PictureBox picFoglio 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   4095
      Left            =   2460
      ScaleHeight     =   4035
      ScaleWidth      =   6075
      TabIndex        =   10
      Top             =   120
      Width           =   6135
   End
   Begin VB.Frame Frame2 
      Caption         =   "Interp. Iperbolica:"
      Height          =   2775
      Left            =   180
      TabIndex        =   0
      Top             =   120
      Width           =   2055
      Begin VB.CommandButton cmdCalcolaIpeInte 
         Caption         =   "Calcola"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   2280
         Width           =   1095
      End
      Begin VB.Label Label7 
         BackStyle       =   0  'Transparent
         Caption         =   "Min."
         Height          =   255
         Left            =   1560
         TabIndex        =   9
         Top             =   1800
         Width           =   375
      End
      Begin VB.Label Label6 
         BackStyle       =   0  'Transparent
         Caption         =   "X3"
         Height          =   255
         Left            =   1560
         TabIndex        =   8
         Top             =   1320
         Width           =   375
      End
      Begin VB.Label Label5 
         BackStyle       =   0  'Transparent
         Caption         =   "X2"
         Height          =   255
         Left            =   1560
         TabIndex        =   7
         Top             =   840
         Width           =   375
      End
      Begin VB.Label Label4 
         BackStyle       =   0  'Transparent
         Caption         =   "X1"
         Height          =   255
         Left            =   1560
         TabIndex        =   6
         Top             =   360
         Width           =   375
      End
      Begin VB.Label lblMinIpeInte 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1800
         Width           =   1335
      End
      Begin VB.Label lblX3IpeInte 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   1320
         Width           =   1335
      End
      Begin VB.Label lblX2IpeInte 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   840
         Width           =   1335
      End
      Begin VB.Label lblX1IpeInte 
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.Menu mnuInfo 
      Caption         =   "&?"
      Begin VB.Menu mnuInformazioni 
         Caption         =   "&Informazioni"
      End
   End
End
Attribute VB_Name = "frmSimplex"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   Form di prova della Subroutine SIMPLEX.
'
'   Per il modo d' impiego vedere il codice di:
'   - cmdCalcolaIpeInte: interamente commentata.
'   - cmdCalcolaMaxim
'   - cmdCalcolaProgLin
'   - cmdCalcolaRose
'   - cmdCalcolaZone
'
'   La descrizione delle funzioni di prova sta', rispettivamente,
'   nel codice delle Funzioni:
'   - IPEINTE
'   - MAXIM
'   - PROGLIN
'   - ROSEMBR
'   - ZONE
'
Option Explicit
'
Public Funzione$
'
Private Const MaxNL& = 15
'
' Variabili per IPEINTE:
Dim XDati#(), YDati#()
'
' Variabili per PROGLIN:
Dim Mm#
'
' Variabili per ZONE:
Dim Xc!(), Yc!()

Public Function IPEINTE(X#()) As Double
'
'   ----------------------------------------------------------------
'   Definizione & Calcolo del valore della funzione da minimizzare:
'
'   ---->   IPEINTE:
'   ---->   Interpolazione iperbolica  (X - X(1))*(Y - X(2)) = X(3)
'   ---->   con minimizzazione della somma degli errori al quadrato.
'
    Dim I&, Y#, FVal#, EQ#
'
    ' Devono essere X(1) < 0 e X(2) > 0 e X(3) < 0.
    ' Se non lo sono do' un valore estremo alla funzione:
    If (X(1) >= 0) Or (X(2) <= 0) Or (X(3) >= 0) Then
        IPEINTE = 1E+38
        Exit Function
    End If
'
    FVal = 0#
    For I = 1 To UBound(XDati)
        Y = X(2) + X(3) / (XDati(I) - X(1))
        EQ = (YDati(I) - Y) ^ 2
        FVal = FVal + EQ
    Next I
'
    IPEINTE = FVal
'
'
'
End Function

Public Function ROSEMBR(X#()) As Double
'
'   ----------------------------------------------------------------
'   Definizione & Calcolo del valore della funzione da minimizzare:
'
'   ---->   ROSEMBROOK:
'   ---->   Superficie quadratica concava.
'
'
    ROSEMBR = 100# * (X(2) - X(1) ^ 2) ^ 2 + (1# - X(1)) ^ 2
'
'
'
End Function

Private Sub cmdCalcolaIpeInte_Click()
'
'
    Dim I&, F&, M$, NPAR&, X#()
    Dim MaxCicli&, ValMinDf#, FSO As Boolean
    Dim IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, NCiclo&, NCC&, OpS$
    Dim ValBV_O#
'
    ' Prepara il PictureBox picFoglio a rappresentare l' evoluzione
    ' della ricerca (non necessario nei casi reali) e imposta
    ' (se richieste) le condizioni iniziali della Funzione
    ' da minimizzare:
    Call FoglioIPEINTE
'
    ' Definisce i criteri di terminazione della ricerca
    ' e di rinnovo dei parametri:
    MaxCicli = 1000         ' N. Max di cicli di ricerca.
    ValMinDf = 0.0001       ' ValDf minimo per il Rinnovo Parametri.
'
    ' Definisce il numero di parametri della funzione da
    ' minimizzare ed il loro vettore:
    NPAR = 3
    ReDim X(1 To NPAR)
    Funzione$ = "IpeInte"
'
    With frmSimplexOp
'
    ' Esegue una prima chiamata alla routine di impostazione delle
    ' condizioni iniziali. Non viene usato il vettore di impostazione
    ' dei parametri:
    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR, False, X())
    ValBV_O = 1E+39 ' Viene sicuramente rappresentato il primo passo.
'
    ' Carica il Form che rappresenta lo stato della ricerca.
    ' Questa informazione continua e' opzionale e puo' non
    ' essere desiderata:
    .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, 0, ""
'
    ' Verifica, nel caso generale, che sia stato precedentemente
    ' caricato il Form frmSimplexOp. Decisamente pleonastico in
    ' questa versione dimostrativa dove il Form in questione
    ' e' stato caricato all' istruzione precedente:
    FSO = IsLoaded(frmSimplexOp)
'
    Do  ' Ciclo di ricerca con chiamate successive a SIMPLEX:
        Call SIMPLEX(IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, NCC, OpS$, X())

        ' Aggiorna, se e' stato caricato, il Form di stato ricerca:
        If FSO Then .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, OpS$
'
        ' Verifica se l' ultimo passo di ricerca ha trovato
        ' un risultato migliore:
        If ValBV_O > ValBV Then
            ValBV_O = ValBV
'
            ' Aggiorna grafica e valori; assolutamente non
            ' necessario nei casi reali dove, invece, verranno
            ' semplicemente memorizzati i valori di X():
            picFoglio.Cls
            picFoglio.PSet (XDati(1), _
            X(2) + X(3) / (XDati(1) - X(1))), vbYellow
            For I = 2 To 11
                picFoglio.Line -(XDati(I), _
                X(2) + X(3) / (XDati(I) - X(1))), vbYellow
            Next I
'
            lblX1IpeInte = Format$(X(1), "0.000E+00")
            lblX2IpeInte = Format$(X(2), "0.000E+00")
            lblX3IpeInte = Format$(X(3), "0.000E+00")
            lblMinIpeInte = Format$(ValBV, "0.000E+00")
        End If
        DoEvents
'
        ' Questa funzione puo' avere minimi locali e puo' quindi
        ' convenire ripetere la ricerca con diverse distribuzioni
        ' iniziali dei parametri. In questo caso particolare
        ' (regressione) e' preferibile non usare il vettore di
        ' impostazione dei parametri per poter, eventualmente,
        ' saltar fuori piu' facilmente dai minimi locali.
        ' La funzione viene invocata o su chiamata dell' osservatore,
        ' con il commando "Rinnova i Parametri", o quando
        ' il valore ValDf scende sotto un limite prestabilito:
        If frmSimplexOp.FRinnova Or ValDf < ValMinDf Then
            Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR _
            , False, X())
            frmSimplexOp.FRinnova = False
        End If
'
    ' Continua la ricerca finche' non sono stati raggiunti i criteri
    ' di terminazione (valore di NCiclo, di NCC, di ValDf, etc..)
    ' o non e' stato premuto lo Stop sul Form di stato ricerca:
    Loop While (NCiclo < MaxCicli) And (Not frmSimplexOp.FStop)
'
    End With
    ' Scarica il Form di stato ricerca:
    If FSO Then Unload frmSimplexOp
'
'
'
End Sub
Private Function IsLoaded(ByVal F_Form As Form) As Boolean
'
'   Ritorna True se il Form F_Form e' gia' caricato in memoria.
'
    Dim X&
'
    For X = 0 To Forms.Count - 1
        If Forms(X) Is F_Form Then
            IsLoaded = True
            Exit Function
        End If
    Next X
'
    IsLoaded = False
'
'
'
End Function

Private Sub cmdCalcolaMaxim_Click()
'
'
    Dim I&, F&, M$, NPAR&, X#()
    Dim MaxCicli&, ValMinDf#
    Dim IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, NCiclo&, NCC&, OpS$
    Dim ValBV_O#
'
    FoglioMAXIM
'
    MaxCicli = 20000        ' N. Max di cicli di ricerca.
    ValMinDf = 0.000000001  ' ValDf minimo per il Rinnovo Parametri.
'
    NPAR = 1
    ReDim X(1 To NPAR)
    Funzione$ = "Maxim"
'
    With frmSimplexOp
'
    X(1) = 10  ' Valore stimato da ottimizzare.
    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR, True, X())
    ValBV_O = 1E+39
    .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, 0, ""
'
    Do
        Call SIMPLEX(IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, NCC, OpS$, X())
        .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, NCiclo, OpS$
'
        If ValBV_O > ValBV Then
            ValBV_O = ValBV
'
            picFoglio.Circle (X(1), -X(1) ^ 2 + 1), 0.05, vbYellow
'
            lblX1Maxim = Format$(X(1), "0.000E+00")
            lblMaxMaxim = Format$(-ValBV, "0.000E+00")
        End If
        DoEvents
'
        'If frmSimplexOp.FRinnova Then
        '    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR _
            , False, X())
        '    frmSimplexOp.FRinnova = False
        'End If
'
    ' Questa funzione non ha minimi locali e si puo' quindi
    ' usare un valore minimo di ValDf per interrompere la ricerca:
    Loop While (ValDf > ValMinDf) And (NCiclo < MaxCicli) _
    And (Not frmSimplexOp.FStop)
'
    picFoglio.Circle (X(1), -X(1) ^ 2 + 1), 0.1, vbRed
'
    End With
    Unload frmSimplexOp
'
'
'
End Sub


Private Sub cmdCalcolaProgLin_Click()
'
'
    Dim I&, F&, M$, NPAR&, X#()
    Dim MaxCicli&, ValMinDf#, ValMinDf_T#
    Dim IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, NCiclo&, NCC&, OpS$
    Dim ValBV_O#
'
    FoglioPROGLIN
'
    MaxCicli = 2000         ' N. Max di cicli di ricerca.
    ValMinDf = 0.00001      ' ValDf minimo per il Rinnovo Parametri.
    ValMinDf_T = 10# * ValMinDf
'
    NPAR = 2
    ReDim X(1 To NPAR)
    Funzione$ = "Prog. Lineare"
'
    With frmSimplexOp
'
    X(1) = 5
    X(2) = 5
    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR, True, X())
    ValBV_O = 1E+39
    .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, 0, ""
 '
    Do
        Call SIMPLEX(IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, NCC, OpS$, X())
        .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, NCiclo, OpS$
'
        If ValBV_O > ValBV Then
            ValBV_O = ValBV
'
            picFoglio.Circle (X(1), X(2)), 0.2, vbYellow
'
            lblX1ProgLin = Format$(X(1), "#0.000")
            lblX2ProgLin = Format$(X(2), "#0.000")
            lblMinProgLin = Format$(Mm# * ValBV, "0.000E+00")
        End If
        DoEvents
'
        ' Conviene esplorare i dintorni del miglior punto
        ' ottenuto per evitare di rimaner intrappolati in
        ' un vicolo cieco (e. g. quando il Simplesso percorre
        ' una traiettoria ortogonale ad una superficie di vincolo):
        If ValDf < ValMinDf_T Then
            Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR _
            , True, X())
             ValMinDf_T = ValMinDf_T / 10#
        End If
'
    ' Questa funzione non ha minimi locali e si puo' quindi
    ' usare un valore minimo di ValDf per interrompere la ricerca:
    Loop While (ValDf > ValMinDf) And (NCiclo < MaxCicli) _
    And (Not frmSimplexOp.FStop)
'
    picFoglio.Circle (X(1), X(2)), 0.6, vbRed
'
    End With
    Unload frmSimplexOp
'
'
'
End Sub

Private Sub cmdCalcolaRose_Click()
'
'
    Dim I&, F&, M$, NPAR&, X#()
    Dim MaxCicli&, ValMinDf#
    Dim IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, NCiclo&, NCC&, OpS$
    Dim ValBV_O#
'
    FoglioROSEMBR
'
    MaxCicli = 20000        ' N. Max di cicli di ricerca.
    ValMinDf = 0.0000001    ' ValDf minimo per il Rinnovo Parametri.
'
    NPAR = 2
    ReDim X(1 To NPAR)
    Funzione$ = "Rosembrook"
'
    With frmSimplexOp
'
    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR, False, X())
    ValBV_O = 1E+39
    .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, 0, ""
'
    Do
        Call SIMPLEX(IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, NCC, OpS$, X())
        .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, NCiclo, OpS$
'
        If ValBV_O > ValBV Then
            ValBV_O = ValBV
'
            picFoglio.Circle (X(1), X(2)), 0.1, vbYellow
'
            lblX1Rose = Format$(X(1), "#0.000")
            lblX2Rose = Format$(X(2), "#0.000")
            lblMinRose = Format$(ValBV, "0.000E+00")
        End If
        DoEvents
'
        'If frmSimplexOp.FRinnova Then
        '    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR _
            , False, X())
        '    frmSimplexOp.FRinnova = False
        'End If
'
    ' Questa funzione non ha minimi locali e si puo' quindi
    ' usare un valore minimo di ValDf per interrompere la ricerca:
    Loop While (ValDf > ValMinDf) And (NCiclo < MaxCicli) _
    And (Not frmSimplexOp.FStop)
'
    picFoglio.Circle (X(1), X(2)), 0.2, vbRed
'
    End With
    Unload frmSimplexOp
'
'
'
End Sub


Private Sub cmdCalcolaZone_Click()
'
'
    Dim I&, J&, K&, DQmin!, DQ!, F&, lblX&, M$, NPAR&, X#()
    Dim MaxCicli&, ValMinDf#
    Dim IBestV&, IWorstV&, ValBV#, ValWV#, ValDf#, NCiclo&, NCC&, OpS$
    Dim ValBV_O#
'
    FoglioZONE
'
    MaxCicli = 10000        ' N. Max di cicli di ricerca.
    ValMinDf = 0.0001       ' ValDf minimo per il Rinnovo Parametri.
'
    NPAR = 8 '6 '4 '2       ' 2 * n; n = numero di punti da cercare.
    lblX = IIf(lblXZone.Count <= NPAR / 2, lblXZone.Count, NPAR / 2)
    ReDim X(1 To NPAR)
    Funzione$ = "Zone"
'
    With frmSimplexOp
'
    Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR, False, X())
    ValBV_O = 1E+39
    .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, 0, ""
'
    Do
        Call SIMPLEX(IBestV, IWorstV, ValBV, ValWV, ValDf _
        , NCiclo, NCC, OpS$, X())
        .SimplexOP IBestV, IWorstV, ValBV, ValWV, ValDf, NCiclo, OpS$
'
        If ValBV_O > ValBV Then
            ValBV_O = ValBV
'
            picFoglio.Cls
            For J = 1 To UBound(X) / 2
                picFoglio.Circle (X(2 * J - 1), X(2 * J)), 0.2, vbYellow
            Next J
'
            For I = 1 To UBound(Xc)
                DQmin = 1E+38
                For J = 1 To UBound(X) / 2
                    DQ = (Xc(I) - X(2 * J - 1)) ^ 2 _
                    + (Yc(I) - X(2 * J)) ^ 2
                    If DQmin > DQ Then
                        DQmin = DQ
                        K = J
                    End If
                Next J
                picFoglio.Line (Xc(I), Yc(I)) _
                -(X(2 * K - 1), X(2 * K)), vbMagenta
            Next I
'
            For J = 1 To lblX
                lblXZone(J) = Format$(X(2 * J - 1), "#0.00")
                lblYZone(J) = Format$(X(2 * J), "#0.00")
            Next J
            lblMinZone = Format$(ValBV, "0.00E+00")
        End If
        DoEvents
'
'
        ' Questa funzione puo' avere minimi locali e puo' quindi
        ' convenire ripetere la ricerca con diverse distribuzioni
        ' iniziali dei parametri. L' ultimo set di parametri ottenuti,
        ' NON viene usato per la chiamata:
        If frmSimplexOp.FRinnova Or ValDf < ValMinDf Then
            Call SIMPLES(IBestV, IWorstV, ValBV, ValWV, ValDf, NPAR _
            , False, X())
            frmSimplexOp.FRinnova = False
        End If
'
    Loop While (NCiclo < MaxCicli) And (Not frmSimplexOp.FStop)
'
    End With
    Unload frmSimplexOp
'
'
'
End Sub

Private Sub cmdChiudi_Click()
'
'
    End
'
'
'
End Sub

Private Sub cmdMmProgLin_Click()
'
'
    If Mm > 0 Then
        Mm = -1#
        lblMmProgLin = "Max."
        cmdMmProgLin.Caption = "Min"
    Else
        Mm = 1#
        lblMmProgLin = "Min."
        cmdMmProgLin.Caption = "Max"
    End If
'
'
'
End Sub

Private Sub Form_Load()
'
'
    Me.Move (Screen.Width - Me.Width) / 2 _
    , (Screen.Height - Me.Height) / 2, 8865, 6555
'
    Mm = 1#
'
'
'
End Sub


Private Sub Form_Unload(Cancel As Integer)
'
'
    End
'
'
'
End Sub


Private Sub mnuInformazioni_Click()
'
'
    frmCopyright.Show vbModal
'
'
'
End Sub



Public Function MAXIM(X#()) As Double
'
'   ----------------------------------------------------------------
'   Definizione & Calcolo del valore della funzione da massimizzare:
'
'   ---->   MAXIM:
'   ---->   Parabola (y = -x^2 + 1), con concavita' verso
'   ---->   il basso, di cui si vuole trovare il massimo soggetto
'   ---->   al vincolo x >= 0.5.
'   ---->   Semplice esempio di massimizzazione
'   ---->   con vincoli sul parametro.
'
    Dim FVal#
'
    ' Se il parametro e' fuori dal campo ammesso do'
    ' un valore estremo alla funzione:
    If X(1) < 0.5 Then
        MAXIM = 1E+38
        Exit Function
    End If
'
    FVal = -(X(1) ^ 2) + 1
'
    ' Poiche' voglio massimizzare inverto il valore:
    MAXIM = -FVal
'
'
'
End Function

Private Sub FoglioIPEINTE()
'
'
    Dim I&
    Dim IX1!, IX2!, IY1!, IY2!
    ReDim XDati(1 To 11), YDati(1 To 11)
'
    ' Dati di scala:
    IX1 = -1
    IY1 = -10
    IX2 = 25
    IY2 = 200
'
    picFoglio.BackColor = vbBlack
    picFoglio.Scale (IX1, IY2)-(IX2, IY1)
    picFoglio.AutoRedraw = True
'
    ' Assi:
    picFoglio.Line (IX1, 0)-(IX2, 0), vbGreen
    picFoglio.Line (0, IY1)-(0, IY2), vbGreen
'
    ' Coppie x, y da interpolare con una
    ' curva iperbolica:
    XDati(1) = 0#: YDati(1) = 0#
    XDati(2) = 2.1: YDati(2) = 48.27
    XDati(3) = 3#: YDati(3) = 64.36
    XDati(4) = 4.5: YDati(4) = 80.45
    XDati(5) = 5.7: YDati(5) = 96.54
    XDati(6) = 7.5: YDati(6) = 112.63
    XDati(7) = 9.2: YDati(7) = 128.72
    XDati(8) = 11.6: YDati(8) = 144.81
    XDati(9) = 14.3: YDati(9) = 160.9
    XDati(10) = 17.2: YDati(10) = 176.99
    XDati(11) = 20.5: YDati(11) = 193.08
'
    ' Disegno dei punti da interpolare:
    For I = 1 To UBound(XDati)
        picFoglio.Circle (XDati(I), YDati(I)), 0.3, vbRed
    Next I
'
    picFoglio.AutoRedraw = False
'
'
'
End Sub

Private Sub FoglioROSEMBR()
'
'
    Dim I&, J&, K&, DMin!, DMax!, Msg$
    Dim RX1!, RX2!, RY1!, RY2!
    Dim RD!(0 To 50, 0 To 50), RX!(0 To 50), RY!(0 To 50)
    Dim RZ!(0 To MaxNL - 1)
'
    ' Dati di scala:
    RX1 = -5!
    RY1 = -5!
    RX2 = 5!
    RY2 = 5!
'
    picFoglio.BackColor = vbBlack
    picFoglio.Scale (RX1, RY2)-(RX2, RY1)
    picFoglio.AutoRedraw = False
'
    ' Assi:
    picFoglio.Line (RX1, 0)-(RX2, 0), vbGreen
    picFoglio.Line (0, RY1)-(0, RY2), vbGreen
'
    ' Dati delle curve di livello:
    ReDim P#(1 To 2)
    DMin = 1E+38
    DMax = -1E+38
    For I = 0 To 50
        RX(I) = RX1 + I * (RX2 - RX1) / 50!
        For J = 0 To 50
            RY(J) = RY1 + J * (RY2 - RY1) / 50!
            P(1) = RX(I)
            P(2) = RY(J)
            RD(I, J) = ROSEMBR(P())
            If DMin > RD(I, J) Then DMin = RD(I, J)
            If DMax < RD(I, J) Then DMax = RD(I, J)
        Next J
    Next I
    DMin = DMin + 15
    DMax = DMax / 10
    For K = 0 To UBound(RZ)
        RZ(K) = DMin + K * (DMax - DMin) / UBound(RZ)
        'RZ(K) = DMin + K * 150
    Next K
'
    ' Disegno dei livelli della superficie:
    CONREC picFoglio, RD(), RX(), RY(), RZ(), Msg$
    If Msg$ <> "" Then MsgBox Msg$
'
'
'
End Sub

Private Sub FoglioMAXIM()
'
'
    Dim X!
    Dim MX1!, MX2!, MY1!, MY2!
'
    ' Dati di scala:
    MX1 = -1!
    MY1 = -5!
    MX2 = 3!
    MY2 = 2!
'
    picFoglio.BackColor = vbBlack
    picFoglio.Scale (MX1, MY2)-(MX2, MY1)
    picFoglio.AutoRedraw = True
'
    ' Assi:
    picFoglio.Line (MX1, 0)-(MX2, 0), vbGreen
    picFoglio.Line (0, MY1)-(0, MY2), vbGreen
'
    ' Funzione:
    picFoglio.PSet (MX1, -(MX1 ^ 2) + 1)
    For X = MX1 + 0.1 To MX2 Step 0.1
        picFoglio.Line -(X, -(X ^ 2) + 1), vbWhite
    Next X
'
    ' Vincolo:
    picFoglio.Line (0.5, MY1)-(0.5, MY2), vbCyan
'
    picFoglio.AutoRedraw = False
'
'
'
End Sub

Public Function PROGLIN(X#()) As Double
'
'   ----------------------------------------------------------------
'   Definizione & Calcolo del valore della funzione da ottimizzare:
'
'   ---->   PROGLIN:
'   ---->   -X(1) + 2 * X(2) - 5: Funzione da minimizzare/massimizzare.
'   ---->   X(2) <=  9 * X(1):    Primo vincolo.
'   ---->   X(2) >= X(1) / 4:     Secondo vincolo.
'   ---->   X(2) <= 30 - X(1):    Terzo vincolo.
'   ---->   Semplice esempio di programmazione lineare.
'
'   ---->   Mm = +1: Se voglio minimizzare.
'   ---->   Mm = -1: Se voglio massimizzare.
'
    Dim FVal#
'
    ' Se i parametri sono fuori dal campo ammesso do'
    ' un valore estremo alla funzione:
    'If (X(2) > 9# * X(1)) _
    'Or (X(2) < X(1) / 4#) _
    'Or (X(2) > 30# - X(1)) Then
    '    PROGLIN = 1E+38
    '    Exit Function
    'End If
'
    FVal = -X(1) + 2# * X(2) - 5#
'
    ' Altra tecnica possibile per soddisfare i vincoli.
    ' Se i parametri sono fuori dal campo ammesso aumento/diminuisco
    ' la funzione di una quantita' proporzionale all' errore:
    If X(2) > 9# * X(1) Then
        FVal = FVal + Mm * 10# * Abs(X(2) - 9# * X(1))
    End If
    If X(2) < X(1) / 4# Then
        FVal = FVal + Mm * 10# * Abs(X(2) - X(1) / 4#)
    End If
    If X(2) > 30# - X(1) Then
        FVal = FVal + Mm * 10# * Abs(X(2) - (30# - X(1)))
    End If
'
    PROGLIN = Mm * FVal
'
'
'
End Function

Private Sub FoglioPROGLIN()
'
'
    Dim I&, J&, K&, DMin!, DMax!, Msg$
    Dim PX1!, PX2!, PY1!, PY2!
    Dim PD!(0 To 30, 0 To 30), PX!(0 To 30), PY!(0 To 30)
    Dim PZ!(0 To MaxNL - 1)
'
    ' Dati di scala:
    PX1 = -1!
    PY1 = -1!
    PX2 = 30!
    PY2 = 30!
'
    picFoglio.BackColor = vbBlack
    picFoglio.Scale (PX1, PY2)-(PX2, PY1)
    picFoglio.AutoRedraw = False
'
    ' Assi:
    picFoglio.Line (PX1, 0)-(PX2, 0), vbGreen
    picFoglio.Line (0, PY1)-(0, PY2), vbGreen
'
    ' Vincoli:
    picFoglio.Line (PX1, 9 * PX1)-(PX2, 9 * PX2), vbCyan
    picFoglio.Line (PX1, PX1 / 4)-(PX2, PX2 / 4), vbCyan
    picFoglio.Line (PX1, 30 - PX1)-(PX2, 30 - PX2), vbCyan
'
    ' Dati delle curve di livello:
    ReDim P#(1 To 2)
    DMin = 1E+38
    DMax = -1E+38
    For I = 0 To 30
        PX(I) = PX1 + I * (PX2 - PX1) / 30!
        For J = 0 To 30
            PY(J) = PY1 + J * (PY2 - PY1) / 30!
            P(1) = PX(I)
            P(2) = PY(J)
            PD(I, J) = PROGLIN(P())
            If DMin > PD(I, J) Then DMin = PD(I, J)
            If DMax < PD(I, J) Then DMax = PD(I, J)
        Next J
    Next I
    DMin = DMin + 5
    DMax = DMax - 5
    For K = 0 To UBound(PZ)
        PZ(K) = DMin + K * (DMax - DMin) / UBound(PZ)
        'PZ(K) = DMin + 2 * K
    Next K
'
    ' Disegno dei livelli della superficie:
    'CONREC picFoglio, PD(), PX(), PY(), PZ(), Msg$
    'If Msg$ <> "" Then MsgBox Msg$
'
'
'
End Sub

Private Sub FoglioZONE()
'
'
    Dim I&, J&, K&
    Dim ZX1!, ZX2!, ZY1!, ZY2!
    ReDim Xc(1 To 100), Yc(1 To 100)
    'ReDim Xc(1 To 4), Yc(1 To 4)
'
    ' Dati di scala:
    ZX1 = -1!
    ZY1 = -1!
    ZX2 = 11!
    ZY2 = 11!
'
    picFoglio.BackColor = vbBlack
    picFoglio.Scale (ZX1, ZY2)-(ZX2, ZY1)
    picFoglio.AutoRedraw = True
'
    ' Assi:
    picFoglio.Line (ZX1, 0)-(ZX2, 0), vbGreen
    picFoglio.Line (0, ZY1)-(0, ZY2), vbGreen
'
    ' Generazione dei punti:
    For I = 1 To Int(Sqr(UBound(Xc)))
        For J = 1 To Int(Sqr(UBound(Yc)))
            K = (I - 1) * Int(Sqr(UBound(Xc))) + J
'
            ' Distribuzione casuale dei punti:
            Xc(K) = RandU(0, 10)
            Yc(K) = RandU(0, 10)
            'Xc(K) = RandN(5, 2)
            'Yc(K) = RandN(5, 2)
'
            ' Distribuzione regolare dei punti
            ' per prova:
            'Xc(K) = I * 10 / Sqr(UBound(Xc))
            'Yc(K) = J * 10 / Sqr(UBound(Yc))
        Next J
    Next I
'
    ' Disegno dei punti:
    For I = 1 To UBound(Xc)
        picFoglio.Circle (Xc(I), Yc(I)), 0.1, vbRed
    Next I
'
    picFoglio.AutoRedraw = False
'
'
'
End Sub

Public Function ZONE(X#()) As Double
'
'   ----------------------------------------------------------------
'   Definizione & Calcolo del valore della funzione da minimizzare:
'
'   ---->   ZONE:
'   ---->   Trova la posizione di n punti (4 in questo caso), con
'   ---->   coordinate (Xz(1 To n), Yz(1 To n)) tali da minimizzare la
'   ---->   somma delle distanze al quadrato da un gruppo di m punti
'   ---->   (m >= n) dati con coordinate (Xc(1 To m), Yc(1 To m)).
'   ---->   Si tratta di un caso di ottimizzazione non lineare,
'   ---->   normalmente abbastanza complesso da risolvere a causa
'   ---->   di molteplici minimi locali con valori molto vicini.
'   ---->   Conviene procedere in due passi:
'   ---->   Il primo e' quello fatto nel codice di cmdCalcolaZone
'   ---->   e prevede un' esplorazione casuale dello spazio a 2 * n
'   ---->   dimensioni, ripartendo, ogni volta, con un nuovo set di
'   ---->   parametri. Il criterio di terminazione e' un MaxCicli
'   ---->   molto grande.
'   ---->   Il secondo passo dovrebbe consistere in una prolungata
'   ---->   ottimizzazione del miglior set di parametri trovato nel
'   ---->   passo precedente. Il criterio di terminazione potra'
'   ---->   essere un ValMinDf molto piccolo.
'
    Dim I&, J&, K&, DQ#, DQmin#, FVal#
    ReDim Xz#(1 To UBound(X) / 2), Yz#(1 To UBound(X) / 2)
    ReDim Nz&(1 To UBound(X) / 2)
'
    ' Se uno dei parametri e' fuori dal campo ammesso do'
    ' un valore estremo alla funzione:
    For I = 1 To UBound(X)
        If (X(I) < 0) Or (X(I) > 10) Then
            ZONE = 1E+38
            Exit Function
        End If
    Next I
'
    ' Risistemo i parametri del vettore X() come coordinate
    ' Xz(), Yx() dei punti da trovare:
    For J = 1 To UBound(Xz)
        Xz(J) = X(2 * J - 1)
        Yz(J) = X(2 * J)
    Next J
'
    FVal = 0#
    For I = 1 To UBound(Xc)
        ' Individua quale, fra i punti cercati, e' il
        ' piu' vicino al punto dato I:
        DQmin = 1E+38
        For J = 1 To UBound(Xz)
            DQ = (Xc(I) - Xz(J)) ^ 2 + (Yc(I) - Yz(J)) ^ 2
            If DQmin > DQ Then
                DQmin = DQ
                K = J
            End If
        Next J
        ' e aggancia il punto K al punto I:
        Nz(K) = Nz(K) + 1
        FVal = FVal + DQmin
    Next I
'
    ' Se uno qualsiasi dei punti cercati non ha
    ' contatti, do' un valore estremo alla funzione:
    For K = 1 To UBound(Nz)
        If Nz(K) = 0 Then
            ZONE = 1E+38
            Exit Function
        End If
    Next K
'
    ZONE = FVal
'
'
'
End Function
